import processing.core.*; import processing.phone.*; public class haiku_005 extends PMIDlet{/*******************************
 * first SETUP everything needed
 *******************************/

     // import phone library to be able to go fullscreen
Phone myLG;                    // my phone's name reference

int fps = 5;


public void setup()
{
  framerate(fps);

  myLG = new Phone(this); // create new phone instance/controller
  myLG.fullscreen();      // go full screen

    loadImages();

}



/*******************************
 * CONSTANTS - mode, focus, options
 *******************************/

int MODE_SPLASH = 0;
int MODE_CLOUDS_IN = 1;
int MODE_HAIKU = 2;
int MODE_CLOUDS_OUT = 3;
int MODE_MENU = 4;
int MODE_WRITEHAIKU = 5;
int MODE_SAVEHAIKU = 6;
int MODE_READHAIKU = 7;
int MODE_HAIKU_1 = 21;
int MODE_HAIKU_2 = 22;
int MODE_HAIKU_3 = 23;

int MENUFOCUS_WRITE = 0;
int MENUFOCUS_SAVE = 1;
int MENUFOCUS_READ = 2;

int READMENUFOCUS_1 = 11;
int READMENUFOCUS_2 = 12;
int READMENUFOCUS_3 = 13;
int READMENUFOCUS_4 = 14;
int READMENUFOCUS_5 = 15;

/*******************************
 * VARIABLES
 *******************************/

int mode = MODE_SPLASH;              // splash screen at the start, for a few seconds

int menuFocus = MENUFOCUS_WRITE;     // menu screen, initial focus on write option

int readFocus = READMENUFOCUS_1; // read menu screen, initial focus on first haiku in the list

int splashTimeout = fps * 2;         // time duration of the splash screen
int cloudsInTimeout = fps * 3;  
int haikuTimeout = fps * 2;
int cloudsOutTimeout = fps * 3;



/*******************************
 * define GRAPHICS and load them
 *******************************/

PImage splashScreen;

PImage cloudsIn;
PImage cloudsOut;
PImage clearSky;

PImage haikuLine_1;
PImage haikuLine_2;
PImage haikuLine_3;

PImage menuBackground;
PImage menuitemWrite;
PImage menuitemSave;
PImage menuitemRead;

PImage writeHaiku;
PImage saveHaiku;
PImage readHaikuBackground;
PImage readHaiku_1;
PImage readHaiku_2;
PImage readHaiku_3;
PImage readHaiku_4;
PImage readHaiku_5;


public void loadImages(){
  splashScreen = loadImage("splashScreen.png");
  cloudsIn = loadImage("cloudsIn.png");
  cloudsOut = loadImage("cloudsOut.png");
  clearSky = loadImage("clearSky.png");

  menuBackground = loadImage("menuBackground.png");
  menuitemWrite = loadImage("menuitemWrite.png");
  menuitemSave = loadImage("menuitemSave.png");
  menuitemRead = loadImage("menuitemRead.png");

  haikuLine_1 = loadImage("haikuLine_1.png");
  haikuLine_2 = loadImage("haikuLine_2.png");
  haikuLine_3 = loadImage("haikuLine_3.png");


  writeHaiku = loadImage("writeHaiku.png");
  saveHaiku = loadImage("saveHaiku.png");
  readHaikuBackground = loadImage("readHaikuBackground.png");
  readHaiku_1 = loadImage("readHaiku_1.png");
  readHaiku_2 = loadImage("readHaiku_2.png");
  readHaiku_3 = loadImage("readHaiku_3.png");
  readHaiku_4 = loadImage("readHaiku_4.png");
  readHaiku_5 = loadImage("readHaiku_5.png");

}



/*******************************
 * SCREEN drawing functions
 *******************************/

public void drawSplash(){
  image(splashScreen,0,0);
}

public void drawCloudsIn(){
  image(cloudsIn,0,0);
}

public void drawHaikuLine_1(){
  image(clearSky,0,0);
  image(haikuLine_1,0,0);
}

public void drawHaikuLine_2(){
  image(clearSky,0,0);
  image(haikuLine_2,0,0);
}

public void drawHaikuLine_3(){
  image(clearSky,0,0);
  image(haikuLine_3,0,0);
}

public void drawCloudsOut(){
  image(cloudsOut,0,0);
}

public void drawMenu(int focus){
  if(focus == MENUFOCUS_WRITE){
    image(menuBackground,0,0);
    image(menuitemWrite,0,0);
  }
  else if(focus == MENUFOCUS_SAVE){
    image(menuBackground,0,0);
    image(menuitemSave,0,0);
  }
  else if(focus == MENUFOCUS_READ){
    image(menuBackground,0,0);
    image(menuitemRead,0,0);
  }  
}

public void drawWriteHaiku(){
  image(writeHaiku,0,0);
}

public void drawSaveHaiku(){
  image(saveHaiku,0,0);
}

public void drawReadHaiku(int readFocus){
  if(readFocus == READMENUFOCUS_1){
    image(readHaikuBackground,0,0);
    image(readHaiku_1,0,0);
  }
  else if(readFocus == READMENUFOCUS_2){
    image(readHaikuBackground,0,0);
    image(readHaiku_2,0,0);
  }
  else if(readFocus == READMENUFOCUS_3){
    image(readHaikuBackground,0,0);
    image(readHaiku_3,0,0);
  }  
  else if(readFocus == READMENUFOCUS_4){
    image(readHaikuBackground,0,0);
    image(readHaiku_4,0,0);
  }
  else if(readFocus == READMENUFOCUS_5){
    image(readHaikuBackground,0,0);
    image(readHaiku_5,0,0);
  }  

}
/*******************************
 * DRAWING function
 *******************************/


public void draw(){                          // happens repeatedly (according to framerate)...


  if(mode == MODE_SPLASH){

    if(0 < splashTimeout){            // draws splash screen first
      splashTimeout--;
      drawSplash();
    }
    else{
      mode = MODE_CLOUDS_IN;
    }
  }


  else if(mode == MODE_CLOUDS_IN){

    if(0 < cloudsInTimeout){            // draws clouds-in screen
      cloudsInTimeout--;
      drawCloudsIn();

    }
    else{
      mode = MODE_HAIKU_1;
      cloudsInTimeout = fps * 3;
    }
  }


  else if(mode == MODE_HAIKU_1){

    if(0 < haikuTimeout){            // draws haiku screen 1
      drawHaikuLine_1();
      haikuTimeout--;

    }
    else{
      mode = MODE_HAIKU_2;
      haikuTimeout = fps * 2;
    }
  }


  else if(mode == MODE_HAIKU_2){

    if(0 < haikuTimeout){            // draws haiku screen 2
      drawHaikuLine_2();
      haikuTimeout--;

    }
    else{
      mode = MODE_HAIKU_3;
      haikuTimeout = fps * 2;
    }
  }


  else if(mode == MODE_HAIKU_3){

    if(0 < haikuTimeout){            // draws haiku screen 3
      drawHaikuLine_3();
      haikuTimeout--;

    }
    else{
      mode = MODE_CLOUDS_OUT;
      haikuTimeout = fps * 2;
    }
  }


  else if(mode == MODE_CLOUDS_OUT){

    if(0 < cloudsOutTimeout){            // draws clouds-out screen
      cloudsOutTimeout--;
      drawCloudsOut();

    }
    else{
      mode = MODE_CLOUDS_IN;
      cloudsOutTimeout = fps * 3;
    }   
  }


  else if(mode == MODE_MENU){
    drawMenu(menuFocus);              // then goes to main menu
  }


  else if(mode == MODE_WRITEHAIKU){
    drawWriteHaiku();                // draws write-haiku screen
  }


  else if(mode == MODE_SAVEHAIKU){
    drawSaveHaiku();                // draws save-haiku screen
  }

  else if(mode == MODE_READHAIKU){
    drawReadHaiku(readFocus);        // draws read-haiku screen
  }   

} // close of draw



/*******************************
 * USER INPUT from keypad
 *******************************/

public void keyPressed(){

  if((mode == MODE_CLOUDS_OUT)||(mode == MODE_CLOUDS_IN)){

    mode = MODE_MENU;
  }


  if(mode == MODE_MENU){

    if(keyCode == SOFTKEY1){
      mode = MODE_CLOUDS_IN;
    }

    if(menuFocus == MENUFOCUS_WRITE){ 
      if(keyCode == SOFTKEY2){
        mode = MODE_WRITEHAIKU;
      }
      else if(keyCode == RIGHT){
        menuFocus = MENUFOCUS_SAVE;
      }
      else if(keyCode == LEFT){
        menuFocus = MENUFOCUS_READ;
      }
    }

    else if(menuFocus == MENUFOCUS_SAVE){
      if(keyCode == SOFTKEY2){
        mode = MODE_SAVEHAIKU;
      }
      else if(keyCode == RIGHT){
        menuFocus = MENUFOCUS_READ;
      }
      else if(keyCode == LEFT){
        menuFocus = MENUFOCUS_WRITE;
      }
    }

    else if(menuFocus == MENUFOCUS_READ){ 
      if(keyCode == SOFTKEY2){
        mode = MODE_READHAIKU;
      }
      else if(keyCode == RIGHT){
        menuFocus = MENUFOCUS_WRITE;
      }
      else if(keyCode == LEFT){
        menuFocus = MENUFOCUS_SAVE;
      }
    }

  }


  if((mode == MODE_WRITEHAIKU)||(mode == MODE_SAVEHAIKU)){

    if(keyCode == SOFTKEY1){
      mode = MODE_MENU;
    }
  }


  if(mode == MODE_READHAIKU){

    if(keyCode == SOFTKEY1){
      mode = MODE_MENU;
    }

    if(readFocus == READMENUFOCUS_1){
      if(keyCode == UP){
        readFocus = READMENUFOCUS_5;
      }

      else if(keyCode == DOWN){
        readFocus = READMENUFOCUS_2;
      }
    }

    else if(readFocus == READMENUFOCUS_2){
      if(keyCode == UP){
        readFocus = READMENUFOCUS_1;
      }
      else if(keyCode == DOWN){
        readFocus = READMENUFOCUS_3;
      }
    }

    else if(readFocus == READMENUFOCUS_3){
      if(keyCode == UP){
        readFocus = READMENUFOCUS_2;
      }
      else if(keyCode == DOWN){
        readFocus = READMENUFOCUS_4;
      }
    }

    else if(readFocus == READMENUFOCUS_4){
      if(keyCode == UP){
        readFocus = READMENUFOCUS_3;
      }
      else if(keyCode == DOWN){
        readFocus = READMENUFOCUS_5;
      }
    }

    else if(readFocus == READMENUFOCUS_5){
      if(keyCode == UP){
        readFocus = READMENUFOCUS_4;
      }
      else if(keyCode == DOWN){
        readFocus = READMENUFOCUS_1;
      }
    }
  }
}


public void keyReleased(){    
  if(mode == MODE_SAVEHAIKU){
    mode = MODE_MENU;
    menuFocus = MENUFOCUS_SAVE;
  }
}
}